within ThermofluidStream.UserGuide;
package License "License, Contact and Citation Information"
    extends Modelica.Icons.Information;

  annotation (DocumentationClass=true, Documentation(info="<html>
<p><b>License</b></p>
<p>Licensed by the Deutsches Zentrum f&uuml;r Luft- und Raumfahrt e.V. (DLR) under the 3-Clause BSD License</p>
<p>Copyright &copy; 2020-2021, DLR e.V.</p>
<p>This Modelica package is free software and the use is completely at your own risk; it can be redistributed and/or modified under the terms of the 3-Clause BSD license. For license conditions (including the disclaimer of warranty) visit https://modelica.org/licenses/modelica-3-clause-bsd. </p>
<p>Modelica&reg; is a registered trademark of the Modelica Association. </p>
<p><br><b>Citation Rules</b></p>
<p>If you have used this library for your publication, please cite the following two papers:</p>
<ul>
<li>Zimmer, Dirk (2020).&quot;Robust object-oriented formulation of directed thermofluid stream networks&quot;. In: Mathematical and Computer Modelling of Dynamical Systems 26.3, pp. 204&ndash; 233. <span style=\"font-size: 8pt;\">DOI</span>: 10.1080/13873954.2020.1757726. </li>
<li>Zimmer, Dirk, Michael Mei&szlig;ner, Niels Weber (in review 2021). &quot;The DLR ThermoFluidStream Library&quot; submitted for the 14th International Modelica Conference, Link&ouml;ping, Sweden. </li>
</ul>
<p><br><b>Contact</b></p>
<p>Preferred feedback is to raise an issue on the GitHub repository (also for positive feedback)</p>
<p>If you have other issues contact: <a href=\"dirk.zimmer@dlr.de\">dirk.zimmer@dlr.de</a></p>
<p><br><b>Authors</b></p>
<p>Authors of this library are Micheal Mei&szlig;ner, Niels Weber and Dirk Zimmer.</p>
<p><br><b>Acknowledgements</b></p>
<p>This work has been partially supported by the Helmholtz Gemeinschaft in frame of the research project for on-board diagnosis. Hence we would also like to thank the team of Robert Bosch GmbH for feedback and motivating use-case scenarios. Further thanks goes to Chistopher Laughman from Mitsubishi Electronic Research Center for providing initial feedback. Also the work of Tobias Krenz form TU Darmstadt was providing motivating use cases of the new approach. We are still grateful to Airbus and our former colleagues Dr Alexander Pollok and Dr. Daniel Bender who were pioneering the new methodology. Also we like to thank our colleague Dr. Peter Eschenbacher for his valuable modeling experience on valves and pumps. </p>
</html>", revisions="<html>
<p><img src=\"modelica:/ThermofluidStream/Resources/dlr_logo.png\"/>(c) 2020-2021, DLR, Institute of System Dynamics and Control</p>
</html>"));
end License;
