within ThermofluidStream.UserGuide;
package References "Nomenclature, Literature References"
    extends Modelica.Icons.Information;

  annotation (DocumentationClass=true, Documentation(info="<html>
<p><b>Nomenclature</b></p>
<p><br>Nomenclature used in this library</p>
<ul>
<li>steady mass flow pressure: p / delta: dp</li>
<li>inertial pressure: r / delta: dr</li>
<li>inertance: L</li>
<li>dynamic pressure q / delta: dq</li>
<li>mass flow rate: m_flow</li>
<li>specific enthalpy: h / delta: dh</li>
<li>specific internal energy: u</li>
<li>heat flow: Q_flow</li>
<li>temperature: T</li>
</ul>
<p><b>Literature</b></p>
<p><b><span style=\"font-size: 9pt;\">References reffering directly to this library</span></b></p>
<ul>
<li>Zimmer, Dirk (2020).&quot;Robust object-oriented formulation of directed thermofluid stream networks&quot;. In: Mathematical and Computer Modelling of Dynamical Systems 26.3, pp. 204&ndash; 233. DOI: 10.1080/13873954.2020.1757726. <br><a href=\"https://www.tandfonline.com/doi/full/10.1080/13873954.2020.1757726\">https://www.tandfonline.com/doi/full/10.1080/13873954.2020.1757726</a></li>
<li>Zimmer, Dirk, Michael Mei&szlig;ner, Niels Weber (2021). &quot;The DLR ThermoFluidStream Library&quot; submitted for the 14th International Modelica Conference, Link&ouml;ping, Sweden. </li>
</ul>
<p><b><span style=\"font-size: 9pt;\">Further background references on the methodology:</span></b></p>
<ul>
<li>Zimmer, Dirk. and Daniel Bender Alexander Pollok (2018). &ldquo;Robust Modeling of Directed Thermofluid Flows in Complex Networks&rdquo;. In: Proceedings of the 2nd Japanese Modelica Conference (Tokyo, Japan).<br><a href=\"
https://elib.dlr.de/120701/1/Japan2018Robust.pdf\">https://elib.dlr.de/120701/1/Japan2018Robust.pdf</a></li>
<li>Zimmer, Dirk (2019a). &ldquo;Robust Simulation of StreamDominated Thermo-Fluid Systems: From Unidirectional to Bidirectional Applications&rdquo;. In.</li>
<li>Zimmer, Dirk (2019b). &ldquo;Towards hard real-time simulation ofcomplex fluid networks&rdquo;. In: Proceedings of the 13th International Modelica Conference (Regensburg, Germany). Link&ouml;ping University Electronic Press, Link&ouml;pings universitet, pp. 579&ndash;587. <br><a href=\"https://ep.liu.se/ecp/157/059/ecp19157059.pdf\">https://ep.liu.se/ecp/157/059/ecp19157059.pdf</a></li>
<li>Otter, M. et al. (2019). &ldquo;Thermodynamic Property and Fluid Modeling with Modern Programming Language Constructs&rdquo;. In: Proceedings of the 13th International Modelica Conference (Regensburg, Germany). Link&ouml;ping University Electronic Press, Link&ouml;pings universitet <br><a href=\"https://www.ep.liu.se/ecp/157/060/ecp19157060.pdf\">https://www.ep.liu.se/ecp/157/060/ecp19157060.pdf</a></li>
</ul>
</html>", revisions="<html>
<p><img src=\"modelica:/ThermofluidStream/Resources/dlr_logo.png\"/>(c) 2020-2021, DLR, Institute of System Dynamics and Control</p>
</html>"));
end References;
